diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/he/he-phy.h ns-3.38/src/wifi/model/he/he-phy.h
--- ns-3.37/src/wifi/model/he/he-phy.h	2022-11-01 17:37:24.743395800 -0700
+++ ns-3.38/src/wifi/model/he/he-phy.h	2023-03-16 20:54:23.856869200 -0700
@@ -22,10 +22,14 @@
 #ifndef HE_PHY_H
 #define HE_PHY_H
 
+#include "he-ppdu.h"
+
 #include "ns3/callback.h"
 #include "ns3/vht-phy.h"
 #include "ns3/wifi-phy-band.h"
 
+#include <optional>
+
 /**
  * \file
  * \ingroup wifi
@@ -102,7 +106,7 @@
     void CancelAllEvents() override;
     uint16_t GetStaId(const Ptr<const WifiPpdu> ppdu) const override;
     uint16_t GetMeasurementChannelWidth(const Ptr<const WifiPpdu> ppdu) const override;
-    void StartTx(Ptr<const WifiPpdu> ppdu, const WifiTxVector& txVector) override;
+    void StartTx(Ptr<const WifiPpdu> ppdu) override;
     Time CalculateTxDuration(WifiConstPsduMap psduMap,
                              const WifiTxVector& txVector,
                              WifiPhyBand band) const override;
@@ -112,6 +116,8 @@
     void NotifyCcaBusy(const Ptr<const WifiPpdu> ppdu,
                        Time duration,
                        WifiChannelListType channelType) override;
+    bool CanStartRx(Ptr<const WifiPpdu> ppdu, uint16_t txChannelWidth) const override;
+    Ptr<const WifiPpdu> GetRxPpduFromTxPpdu(Ptr<const WifiPpdu> ppdu) override;
 
     /**
      * \return the BSS color of this PHY.
@@ -148,14 +154,14 @@
      *
      * \return the duration of the non-OFDMA portion of the HE TB PPDU.
      */
-    Time CalculateNonOfdmaDurationForHeTb(const WifiTxVector& txVector) const;
+    virtual Time CalculateNonOfdmaDurationForHeTb(const WifiTxVector& txVector) const;
 
     /**
      * \param txVector the transmission parameters used for the HE MU PPDU
      *
      * \return the duration of the non-OFDMA portion of the HE MU PPDU.
      */
-    Time CalculateNonOfdmaDurationForHeMu(const WifiTxVector& txVector) const;
+    virtual Time CalculateNonOfdmaDurationForHeMu(const WifiTxVector& txVector) const;
 
     /**
      * Get the band in the TX spectrum associated with the RU used by the PSDU
@@ -235,7 +241,7 @@
 
     /**
      * Fire a EndOfHeSigA callback (if connected) once HE-SIG-A field has been received.
-     * This method is scheduled immediatly after end of HE-SIG-A, once
+     * This method is scheduled immediately after end of HE-SIG-A, once
      * field processing is finished.
      *
      * \param params the HE-SIG-A parameters
@@ -446,8 +452,7 @@
     void DoAbortCurrentReception(WifiPhyRxfailureReason reason) override;
     uint64_t ObtainNextUid(const WifiTxVector& txVector) override;
     Ptr<SpectrumValue> GetTxPowerSpectralDensity(double txPowerW,
-                                                 Ptr<const WifiPpdu> ppdu,
-                                                 const WifiTxVector& txVector) const override;
+                                                 Ptr<const WifiPpdu> ppdu) const override;
     uint32_t GetMaxPsduSize() const override;
     WifiConstPsduMap GetWifiConstPsduMap(Ptr<const WifiPsdu> psdu,
                                          const WifiTxVector& txVector) const override;
@@ -475,9 +480,9 @@
     virtual PhyFieldRxStatus ProcessSigB(Ptr<Event> event, PhyFieldRxStatus status);
 
     /**
-     * Start receiving the PSDU (i.e. the first symbol of the PSDU has arrived) of an UL-OFDMA
+     * Start receiving the PSDU (i.e. the first symbol of the PSDU has arrived) of an OFDMA
      * transmission. This function is called upon the RX event corresponding to the OFDMA part of
-     * the UL MU PPDU.
+     * the MU PPDU.
      *
      * \param event the event holding incoming OFDMA part of the PPDU's information
      */
@@ -518,9 +523,11 @@
         m_beginOfdmaPayloadRxEvents; //!< the beginning of the OFDMA payload reception events
                                      //!< (indexed by STA-ID)
 
-    EndOfHeSigACallback m_endOfHeSigACallback; //!< end of HE-SIG-A callback
-    WifiTxVector m_trigVector;                 //!< the TRIGVECTOR
-    Time m_trigVectorExpirationTime;           //!< expiration time of the TRIGVECTOR
+    EndOfHeSigACallback m_endOfHeSigACallback;      //!< end of HE-SIG-A callback
+    std::optional<WifiTxVector> m_trigVector;       //!< the TRIGVECTOR
+    std::optional<Time> m_trigVectorExpirationTime; //!< expiration time of the TRIGVECTOR
+    std::optional<WifiTxVector> m_currentTxVector;  //!< If the STA is an AP STA, this holds the
+                                                    //!< TXVECTOR of the PPDU that has been sent
 
   private:
     void BuildModeList() override;
@@ -528,6 +535,31 @@
     Time GetSymbolDuration(const WifiTxVector& txVector) const override;
 
     /**
+     * This is a helper function to create the TX PSD of the non-HE and HE portions.
+     *
+     * \param txPowerW power in W to spread across the bands
+     * \param ppdu the PPDU that will be transmitted
+     * \param flag flag indicating whether the PSD is for non-HE portion or HE portion
+     * \return Pointer to SpectrumValue
+     */
+    Ptr<SpectrumValue> GetTxPowerSpectralDensity(double txPowerW,
+                                                 Ptr<const WifiPpdu> ppdu,
+                                                 HePpdu::TxPsdFlag flag) const;
+
+    /**
+     * Start the transmission of the OFDMA part of the MU PPDU.
+     *
+     * \param ppdu the PPDU
+     * \param txPowerDbm the total TX power in dBm
+     * \param txPowerSpectrum the TX PSD
+     * \param ofdmaDuration the duration of the OFDMA part
+     */
+    void StartTxOfdma(Ptr<const WifiPpdu> ppdu,
+                      double txPowerDbm,
+                      Ptr<SpectrumValue> txPowerSpectrum,
+                      Time ofdmaDuration);
+
+    /**
      * Notify PHY state helper to switch to CCA busy state,
      *
      * \param duration the duration of the CCA state
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/he/he-ppdu.cc ns-3.38/src/wifi/model/he/he-ppdu.cc
--- ns-3.37/src/wifi/model/he/he-ppdu.cc	2022-11-01 17:37:24.743395800 -0700
+++ ns-3.38/src/wifi/model/he/he-ppdu.cc	2023-03-16 20:54:23.856869200 -0700
@@ -54,8 +54,7 @@
                Time ppduDuration,
                WifiPhyBand band,
                uint64_t uid,
-               TxPsdFlag flag,
-               uint8_t p20Index)
+               TxPsdFlag flag)
     : OfdmPpdu(psdus.begin()->second,
                txVector,
                txCenterFreq,
@@ -72,10 +71,8 @@
     m_psdus = psdus;
     if (txVector.IsMu())
     {
-        for (auto heMuUserInfo : txVector.GetHeMuUserInfoMap())
+        for (const auto& heMuUserInfo : txVector.GetHeMuUserInfoMap())
         {
-            // Set RU PHY index
-            heMuUserInfo.second.ru.SetPhyIndex(txVector.GetChannelWidth(), p20Index);
             auto [it, ret] = m_muUserInfos.emplace(heMuUserInfo);
             NS_ABORT_MSG_IF(!ret, "STA-ID " << heMuUserInfo.first << " already present");
         }
@@ -105,14 +102,29 @@
     SetTxPsdFlag(PSD_NON_HE_PORTION);
 }
 
-HePpdu::~HePpdu()
+void
+HePpdu::SetPhyHeaders(const WifiTxVector& txVector, Time ppduDuration)
 {
+    NS_LOG_FUNCTION(this << txVector << ppduDuration);
+
+#ifdef NS3_BUILD_PROFILE_DEBUG
+    LSigHeader lSig;
+    SetLSigHeader(lSig, ppduDuration);
+
+    HeSigHeader heSig;
+    SetHeSigHeader(heSig, txVector);
+
+    m_phyHeaders->AddHeader(heSig);
+    m_phyHeaders->AddHeader(lSig);
+#else
+    SetLSigHeader(m_lSig, ppduDuration);
+    SetHeSigHeader(m_heSig, txVector);
+#endif
 }
 
 void
-HePpdu::SetPhyHeaders(const WifiTxVector& txVector, Time ppduDuration)
+HePpdu::SetLSigHeader(LSigHeader& lSig, Time ppduDuration) const
 {
-    NS_LOG_FUNCTION(this << txVector << ppduDuration);
     uint8_t sigExtension = 0;
     if (m_band == WIFI_PHY_BAND_2_4GHZ)
     {
@@ -125,20 +137,28 @@
                              4.0) *
                         3) -
                        3 - m);
-    m_lSig.SetLength(length);
-    if (txVector.IsDlMu())
+    lSig.SetLength(length);
+}
+
+void
+HePpdu::SetHeSigHeader(HeSigHeader& heSig, const WifiTxVector& txVector) const
+{
+    if (ns3::IsDlMu(m_preamble))
+    {
+        heSig.SetMuFlag(true);
+        heSig.SetMcs(txVector.GetSigBMode().GetMcsValue());
+    }
+    else if (!ns3::IsUlMu(m_preamble))
     {
-        m_heSig.SetMuFlag(true);
-        m_heSig.SetMcs(txVector.GetSigBMode().GetMcsValue());
+        heSig.SetMcs(txVector.GetMode().GetMcsValue());
+        heSig.SetNStreams(txVector.GetNss());
     }
-    else if (!txVector.IsUlMu())
+    heSig.SetBssColor(txVector.GetBssColor());
+    heSig.SetChannelWidth(txVector.GetChannelWidth());
+    if (!txVector.IsUlMu())
     {
-        m_heSig.SetMcs(txVector.GetMode().GetMcsValue());
-        m_heSig.SetNStreams(txVector.GetNss());
+        heSig.SetGuardIntervalAndLtfSize(txVector.GetGuardInterval(), 2 /*NLTF currently unused*/);
     }
-    m_heSig.SetBssColor(txVector.GetBssColor());
-    m_heSig.SetChannelWidth(m_channelWidth);
-    m_heSig.SetGuardIntervalAndLtfSize(txVector.GetGuardInterval(), 2 /*NLTF currently unused*/);
 }
 
 WifiTxVector
@@ -146,23 +166,60 @@
 {
     WifiTxVector txVector;
     txVector.SetPreambleType(m_preamble);
-    txVector.SetMode(HePhy::GetHeMcs(m_heSig.GetMcs()));
-    txVector.SetChannelWidth(m_heSig.GetChannelWidth());
-    txVector.SetNss(m_heSig.GetNStreams());
-    txVector.SetGuardInterval(m_heSig.GetGuardInterval());
-    txVector.SetBssColor(m_heSig.GetBssColor());
-    txVector.SetLength(m_lSig.GetLength());
+
+#ifdef NS3_BUILD_PROFILE_DEBUG
+    auto phyHeaders = m_phyHeaders->Copy();
+
+    LSigHeader lSig;
+    if (phyHeaders->RemoveHeader(lSig) == 0)
+    {
+        NS_FATAL_ERROR("Missing L-SIG header in HE PPDU");
+    }
+
+    HeSigHeader heSig;
+    if (phyHeaders->PeekHeader(heSig) == 0)
+    {
+        NS_FATAL_ERROR("Missing HE-SIG header in HE PPDU");
+    }
+
+    SetTxVectorFromPhyHeaders(txVector, lSig, heSig);
+#else
+    SetTxVectorFromPhyHeaders(txVector, m_lSig, m_heSig);
+#endif
+
+    return txVector;
+}
+
+void
+HePpdu::SetTxVectorFromPhyHeaders(WifiTxVector& txVector,
+                                  const LSigHeader& lSig,
+                                  const HeSigHeader& heSig) const
+{
+    txVector.SetChannelWidth(heSig.GetChannelWidth());
+    txVector.SetBssColor(heSig.GetBssColor());
+    txVector.SetLength(lSig.GetLength());
     txVector.SetAggregation(m_psdus.size() > 1 || m_psdus.begin()->second->IsAggregate());
-    for (const auto& muUserInfo : m_muUserInfos)
+    if (!IsMu())
+    {
+        txVector.SetMode(HePhy::GetHeMcs(heSig.GetMcs()));
+        txVector.SetNss(heSig.GetNStreams());
+    }
+    if (!IsUlMu())
     {
-        txVector.SetHeMuUserInfo(muUserInfo.first, muUserInfo.second);
+        txVector.SetGuardInterval(heSig.GetGuardInterval());
+    }
+    if (IsDlMu())
+    {
+        for (const auto& muUserInfo : m_muUserInfos)
+        {
+            txVector.SetHeMuUserInfo(muUserInfo.first, muUserInfo.second);
+        }
     }
     if (txVector.IsDlMu())
     {
-        txVector.SetSigBMode(HePhy::GetVhtMcs(m_heSig.GetMcs()));
+        txVector.SetSigBMode(HePhy::GetVhtMcs(heSig.GetMcs()));
         txVector.SetRuAllocation(m_ruAllocation);
     }
-    return txVector;
 }
 
 Time
@@ -170,6 +227,16 @@
 {
     Time ppduDuration = Seconds(0);
     const WifiTxVector& txVector = GetTxVector();
+
+    uint16_t length = 0;
+#ifdef NS3_BUILD_PROFILE_DEBUG
+    LSigHeader lSig;
+    m_phyHeaders->PeekHeader(lSig);
+    length = lSig.GetLength();
+#else
+    length = m_lSig.GetLength();
+#endif
+
     Time tSymbol = NanoSeconds(12800 + txVector.GetGuardInterval());
     Time preambleDuration = WifiPhy::CalculatePhyPreambleAndHeaderDuration(txVector);
     uint8_t sigExtension = 0;
@@ -179,8 +246,8 @@
     }
     uint8_t m = IsDlMu() ? 1 : 2;
     // Equation 27-11 of IEEE P802.11ax/D4.0
-    Time calculatedDuration = MicroSeconds(
-        ((ceil(static_cast<double>(m_lSig.GetLength() + 3 + m) / 3)) * 4) + 20 + sigExtension);
+    Time calculatedDuration =
+        MicroSeconds(((ceil(static_cast<double>(length + 3 + m) / 3)) * 4) + 20 + sigExtension);
     NS_ASSERT(calculatedDuration > preambleDuration);
     uint32_t nSymbols =
         floor(static_cast<double>((calculatedDuration - preambleDuration).GetNanoSeconds() -
@@ -193,7 +260,7 @@
 Ptr<WifiPpdu>
 HePpdu::Copy() const
 {
-    return ns3::Copy(Ptr(this));
+    return Ptr<WifiPpdu>(new HePpdu(*this), false);
 }
 
 WifiPpduType
@@ -236,20 +303,33 @@
         NS_ASSERT(m_psdus.size() == 1);
         return m_psdus.at(SU_STA_ID);
     }
-    else if (IsUlMu())
+
+    uint8_t ppduBssColor = 0;
+#ifdef NS3_BUILD_PROFILE_DEBUG
+    auto phyHeaders = m_phyHeaders->Copy();
+    LSigHeader lSig;
+    phyHeaders->RemoveHeader(lSig);
+    HeSigHeader heSig;
+    phyHeaders->RemoveHeader(heSig);
+    ppduBssColor = heSig.GetBssColor();
+#else
+    ppduBssColor = m_heSig.GetBssColor();
+#endif
+
+    if (IsUlMu())
     {
         NS_ASSERT(m_psdus.size() == 1);
-        if (bssColor == 0 || m_heSig.GetBssColor() == 0 || (bssColor == m_heSig.GetBssColor()))
+        if (bssColor == 0 || ppduBssColor == 0 || (bssColor == ppduBssColor))
         {
-            return m_psdus.begin()->second;
+            return m_psdus.cbegin()->second;
         }
     }
     else
     {
-        if (bssColor == 0 || m_heSig.GetBssColor() == 0 || (bssColor == m_heSig.GetBssColor()))
+        if (bssColor == 0 || ppduBssColor == 0 || (bssColor == ppduBssColor))
         {
-            auto it = m_psdus.find(staId);
-            if (it != m_psdus.end())
+            const auto it = m_psdus.find(staId);
+            if (it != m_psdus.cend())
             {
                 return it->second;
             }
@@ -268,8 +348,8 @@
 uint16_t
 HePpdu::GetTransmissionChannelWidth() const
 {
-    WifiTxVector txVector = GetTxVector();
-    if (txVector.GetPreambleType() == WIFI_PREAMBLE_HE_TB && GetStaId() != SU_STA_ID)
+    const WifiTxVector& txVector = GetTxVector();
+    if (txVector.IsUlMu() && GetStaId() != SU_STA_ID)
     {
         TxPsdFlag flag = GetTxPsdFlag();
         uint16_t ruWidth = HeRu::GetBandwidth(txVector.GetRu(GetStaId()).GetRuType());
@@ -284,18 +364,6 @@
     }
 }
 
-bool
-HePpdu::CanBeReceived(uint16_t p20MinFreq, uint16_t p20MaxFreq) const
-{
-    NS_LOG_FUNCTION(this << p20MinFreq << p20MaxFreq);
-    if (IsUlMu())
-    {
-        // APs are able to receive TB PPDUs sent on a band other than the primary20 channel
-        return true;
-    }
-    return OfdmPpdu::CanBeReceived(p20MinFreq, p20MaxFreq);
-}
-
 HePpdu::TxPsdFlag
 HePpdu::GetTxPsdFlag() const
 {
@@ -303,12 +371,48 @@
 }
 
 void
-HePpdu::SetTxPsdFlag(TxPsdFlag flag)
+HePpdu::SetTxPsdFlag(TxPsdFlag flag) const
 {
     NS_LOG_FUNCTION(this << flag);
     m_txPsdFlag = flag;
 }
 
+void
+HePpdu::UpdateTxVectorForUlMu(const std::optional<WifiTxVector>& trigVector) const
+{
+    if (trigVector.has_value())
+    {
+        NS_LOG_FUNCTION(this << trigVector.value());
+    }
+    else
+    {
+        NS_LOG_FUNCTION(this);
+    }
+    if (!m_txVector.has_value())
+    {
+        m_txVector = GetTxVector();
+    }
+    NS_ASSERT(GetModulation() >= WIFI_MOD_CLASS_HE);
+    NS_ASSERT(GetType() == WIFI_PPDU_TYPE_UL_MU);
+    // HE TB PPDU reception needs information from the TRIGVECTOR to be able to receive the PPDU
+    const auto staId = GetStaId();
+    if (trigVector.has_value() && trigVector->IsUlMu() &&
+        (trigVector->GetHeMuUserInfoMap().count(staId) > 0))
+    {
+        // These information are not carried in HE-SIG-A for a HE TB PPDU,
+        // but they are carried in the Trigger frame soliciting the HE TB PPDU
+        m_txVector->SetGuardInterval(trigVector->GetGuardInterval());
+        m_txVector->SetHeMuUserInfo(staId, trigVector->GetHeMuUserInfo(staId));
+    }
+    else
+    {
+        // Set dummy user info, PPDU will be dropped later after decoding PHY headers.
+        m_txVector->SetHeMuUserInfo(
+            staId,
+            {{HeRu::GetRuType(m_txVector->GetChannelWidth()), 1, true}, 0, 1});
+    }
+}
+
 bool
 HePpdu::IsAllocated(uint16_t staId) const
 {
@@ -353,10 +457,6 @@
 {
 }
 
-HePpdu::HeSigHeader::~HeSigHeader()
-{
-}
-
 TypeId
 HePpdu::HeSigHeader::GetTypeId()
 {
@@ -402,7 +502,7 @@
 void
 HePpdu::HeSigHeader::SetMcs(uint8_t mcs)
 {
-    NS_ASSERT(mcs <= 11);
+    // NS_ASSERT (mcs <= 11); // TODO: reactivate once EHT PHY headers are implemented
     m_mcs = mcs;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/he/he-ppdu.h ns-3.38/src/wifi/model/he/he-ppdu.h
--- ns-3.37/src/wifi/model/he/he-ppdu.h	2022-11-01 17:37:24.743395800 -0700
+++ ns-3.38/src/wifi/model/he/he-ppdu.h	2023-03-16 20:54:23.856869200 -0700
@@ -51,7 +51,6 @@
     {
       public:
         HeSigHeader();
-        ~HeSigHeader() override;
 
         /**
          * \brief Get the type ID.
@@ -187,7 +186,6 @@
      * \param band the WifiPhyBand used for the transmission of this PPDU
      * \param uid the unique ID of this PPDU or of the triggering PPDU if this is an HE TB PPDU
      * \param flag the flag indicating the type of Tx PSD to build
-     * \param p20Index the index of the primary 20 MHz channel
      */
     HePpdu(const WifiConstPsduMap& psdus,
            const WifiTxVector& txVector,
@@ -195,19 +193,13 @@
            Time ppduDuration,
            WifiPhyBand band,
            uint64_t uid,
-           TxPsdFlag flag,
-           uint8_t p20Index);
-    /**
-     * Destructor for HePpdu.
-     */
-    ~HePpdu() override;
+           TxPsdFlag flag);
 
     Time GetTxDuration() const override;
     Ptr<WifiPpdu> Copy() const override;
     WifiPpduType GetType() const override;
     uint16_t GetStaId() const override;
     uint16_t GetTransmissionChannelWidth() const override;
-    bool CanBeReceived(uint16_t p20MinFreq, uint16_t p20MaxFreq) const override;
 
     /**
      * Get the payload of the PPDU.
@@ -230,7 +222,16 @@
      *
      * \see TxPsdFlag
      */
-    void SetTxPsdFlag(TxPsdFlag flag);
+    void SetTxPsdFlag(TxPsdFlag flag) const;
+
+    /**
+     * Update the TXVECTOR for HE TB PPDUs, since the information to decode HE TB PPDUs
+     * is not available from the PHY headers but it requires information from the TRIGVECTOR
+     * of the AP expecting these HE TB PPDUs.
+     *
+     * \param trigVector the TRIGVECTOR or std::nullopt if no TRIGVECTOR is available at the caller
+     */
+    void UpdateTxVectorForUlMu(const std::optional<WifiTxVector>& trigVector) const;
 
     /**
      * Check if STA ID is in HE SIG-B Content Channel ID
@@ -248,6 +249,31 @@
     bool IsAllocated(uint16_t staId) const;
 
   protected:
+    /**
+     * Fill in the TXVECTOR from PHY headers.
+     *
+     * \param txVector the TXVECTOR to fill in
+     * \param lSig the L-SIG header
+     * \param heSig the HE-SIG header
+     */
+    virtual void SetTxVectorFromPhyHeaders(WifiTxVector& txVector,
+                                           const LSigHeader& lSig,
+                                           const HeSigHeader& heSig) const;
+
+#ifndef NS3_BUILD_PROFILE_DEBUG
+    HeSigHeader m_heSig; //!< the HE-SIG PHY header
+#endif
+    mutable TxPsdFlag m_txPsdFlag; //!< the transmit power spectral density flag
+
+    WifiTxVector::HeMuUserInfoMap m_muUserInfos; //!< HE MU specific per-user information (to be
+                                                 //!< removed once HE-SIG-B headers are implemented)
+    ContentChannelAllocation
+        m_contentChannelAlloc; //!< HE SIG-B Content Channel allocation (to be removed once HE-SIG-B
+                               //!< headers are implemented)
+    RuAllocation m_ruAllocation; //!< RU_ALLOCATION in SIG-B common field (to be removed once
+                                 //!< HE-SIG-B headers are implemented)
+
+  private:
     std::string PrintPayload() const override;
     WifiTxVector DoGetTxVector() const override;
 
@@ -256,11 +282,13 @@
      * \return true if the PPDU is a MU PPDU
      */
     virtual bool IsMu() const;
+
     /**
      * Return true if the PPDU is a DL MU PPDU
      * \return true if the PPDU is a DL MU PPDU
      */
     virtual bool IsDlMu() const;
+
     /**
      * Return true if the PPDU is an UL MU PPDU
      * \return true if the PPDU is an UL MU PPDU
@@ -268,24 +296,29 @@
     virtual bool IsUlMu() const;
 
     /**
-     * Fill in the HE PHY headers.
+     * Fill in the PHY headers.
      *
      * \param txVector the TXVECTOR that was used for this PPDU
      * \param ppduDuration the transmission duration of this PPDU
      */
     virtual void SetPhyHeaders(const WifiTxVector& txVector, Time ppduDuration);
 
-    HeSigHeader m_heSig;   //!< the HE-SIG PHY header
-    TxPsdFlag m_txPsdFlag; //!< the transmit power spectral density flag
+    /**
+     * Fill in the L-SIG header.
+     *
+     * \param lSig the L-SIG header to fill in
+     * \param ppduDuration the transmission duration of this PPDU
+     */
+    virtual void SetLSigHeader(LSigHeader& lSig, Time ppduDuration) const;
 
-    WifiTxVector::HeMuUserInfoMap m_muUserInfos; //!< HE MU specific per-user information (to be
-                                                 //!< removed once HE-SIG-B headers are implemented)
-    ContentChannelAllocation
-        m_contentChannelAlloc; //!< HE SIG-B Content Channel allocation (to be removed once HE-SIG-B
-                               //!< headers are implemented)
-    RuAllocation m_ruAllocation; //!< RU_ALLOCATION in SIG-B common field (to be removed once
-                                 //!< HE-SIG-B headers are implemented)
-};                               // class HePpdu
+    /**
+     * Fill in the HE-SIG header.
+     *
+     * \param heSig the HE-SIG header to fill in
+     * \param txVector the TXVECTOR that was used for this PPDU
+     */
+    void SetHeSigHeader(HeSigHeader& heSig, const WifiTxVector& txVector) const;
+}; // class HePpdu
 
 /**
  * \brief Stream insertion operator.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/he/he-ru.cc ns-3.38/src/wifi/model/he/he-ru.cc
--- ns-3.37/src/wifi/model/he/he-ru.cc	2022-11-01 17:37:24.743395800 -0700
+++ ns-3.38/src/wifi/model/he/he-ru.cc	2023-03-16 20:54:23.856869200 -0700
@@ -159,7 +159,8 @@
     {{80, HeRu::RU_484_TONE},
      {/* 1 */ {{-500, -17}},
       /* 2 */ {{17, 500}}}},
-    {{80, HeRu::RU_996_TONE}, {/* 1 */ {{-500, -3}, {3, 500}}}}};
+    {{80, HeRu::RU_996_TONE}, {/* 1 */ {{-500, -3}, {3, 500}}}},
+};
 
 // Table 27-26 IEEE802.11ax-2021
 const HeRu::RuAllocationMap HeRu::m_heRuAllocations = {
@@ -425,8 +426,7 @@
 HeRu::RuSpec::RuSpec(RuType ruType, std::size_t index, bool primary80MHz)
     : m_ruType(ruType),
       m_index(index),
-      m_primary80MHz(primary80MHz),
-      m_phyIndex(0)
+      m_primary80MHz(primary80MHz)
 {
     NS_ABORT_MSG_IF(index == 0, "Index cannot be zero");
 }
@@ -452,35 +452,22 @@
     return m_primary80MHz;
 }
 
-void
-HeRu::RuSpec::SetPhyIndex(uint16_t bw, uint8_t p20Index)
+std::size_t
+HeRu::RuSpec::GetPhyIndex(uint16_t bw, uint8_t p20Index) const
 {
     bool primary80IsLower80 = (p20Index < bw / 40);
 
     if (bw < 160 || m_ruType == HeRu::RU_2x996_TONE || (primary80IsLower80 && m_primary80MHz) ||
         (!primary80IsLower80 && !m_primary80MHz))
     {
-        m_phyIndex = m_index;
+        return m_index;
     }
     else
     {
-        m_phyIndex = m_index + GetNRus(bw, m_ruType) / 2;
+        return m_index + GetNRus(bw, m_ruType) / 2;
     }
 }
 
-bool
-HeRu::RuSpec::IsPhyIndexSet() const
-{
-    return (m_phyIndex != 0);
-}
-
-std::size_t
-HeRu::RuSpec::GetPhyIndex() const
-{
-    NS_ABORT_MSG_IF(m_phyIndex == 0, "RU PHY index not set");
-    return m_phyIndex;
-}
-
 std::size_t
 HeRu::GetNRus(uint16_t bw, RuType ruType)
 {
@@ -653,7 +640,7 @@
 }
 
 bool
-HeRu::DoesOverlap(uint16_t bw, RuSpec ru, const SubcarrierGroup& toneRanges)
+HeRu::DoesOverlap(uint16_t bw, RuSpec ru, const SubcarrierGroup& toneRanges, uint8_t p20Index)
 {
     for (const auto& range : toneRanges)
     {
@@ -662,7 +649,8 @@
             return true;
         }
 
-        SubcarrierGroup rangesRu = GetSubcarrierGroup(bw, ru.GetRuType(), ru.GetPhyIndex());
+        SubcarrierGroup rangesRu =
+            GetSubcarrierGroup(bw, ru.GetRuType(), ru.GetPhyIndex(bw, p20Index));
         for (auto& r : rangesRu)
         {
             if (range.second >= r.first && r.second >= range.first)
@@ -748,10 +736,6 @@
 {
     os << "RU{" << ru.GetRuType() << "/" << ru.GetIndex() << "/"
        << (ru.GetPrimary80MHz() ? "primary80MHz" : "secondary80MHz");
-    if (ru.IsPhyIndexSet())
-    {
-        os << "[" << ru.GetPhyIndex() << "]";
-    }
     os << "}";
     return os;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/he/he-ru.h ns-3.38/src/wifi/model/he/he-ru.h
--- ns-3.37/src/wifi/model/he/he-ru.h	2022-11-01 17:37:24.743395800 -0700
+++ ns-3.38/src/wifi/model/he/he-ru.h	2023-03-16 20:54:23.856869200 -0700
@@ -97,24 +97,13 @@
          */
         bool GetPrimary80MHz() const;
         /**
-         * Set the RU PHY index
+         * Get the RU PHY index
          *
          * \param bw the width of the channel of which the RU is part (in MHz)
          * \param p20Index the index of the primary20 channel
-         */
-        void SetPhyIndex(uint16_t bw, uint8_t p20Index);
-        /**
-         * Return true if the RU PHY index has been set, false otherwise
-         *
-         * \return true if the RU PHY index has been set, false otherwise
-         */
-        bool IsPhyIndexSet() const;
-        /**
-         * Get the RU PHY index
-         *
          * \return the RU PHY index
          */
-        std::size_t GetPhyIndex() const;
+        std::size_t GetPhyIndex(uint16_t bw, uint8_t p20Index) const;
 
         /**
          * Compare this RU to the given RU.
@@ -132,14 +121,10 @@
         bool operator!=(const RuSpec& other) const;
 
       private:
-        RuType m_ruType;        //!< RU type
-        std::size_t m_index;    /**< RU index (starting at 1) as defined by Tables 27-7
-                                     to 27-9 of 802.11ax D8.0 */
-        bool m_primary80MHz;    //!< true if the RU is allocated in the primary 80MHz channel
-        std::size_t m_phyIndex; /**< the RU PHY index, which is used to indicate whether an
-                                     RU is located in the lower half or the higher half of
-                                     a 160MHz channel. For channel widths less than 160MHz,
-                                     the RU PHY index equals the RU index */
+        RuType m_ruType;     //!< RU type
+        std::size_t m_index; /**< RU index (starting at 1) as defined by Tables 27-7
+                                  to 27-9 of 802.11ax D8.0 */
+        bool m_primary80MHz; //!< true if the RU is allocated in the primary 80MHz channel
     };
 
     /**
@@ -208,9 +193,13 @@
      * \param bw the bandwidth (MHz) of the HE PPDU (20, 40, 80, 160)
      * \param ru the given RU allocation
      * \param toneRanges the given set of tone ranges
+     * \param p20Index the index of the primary20 channel
      * \return true if the given RU overlaps with the given set of tone ranges.
      */
-    static bool DoesOverlap(uint16_t bw, RuSpec ru, const SubcarrierGroup& toneRanges);
+    static bool DoesOverlap(uint16_t bw,
+                            RuSpec ru,
+                            const SubcarrierGroup& toneRanges,
+                            uint8_t p20Index);
 
     /**
      * Find the RU allocation of the given RU type overlapping the given
